/**
 * App module.
 * @module app
 */

const BaseGenerator = require('../_base/BaseGenerator');

const TEMPLATES = {
  files: [
    '.env',
    '.env.test',
    '.eslintrc.yml',
    '.eslintignore',
    'tsconfig.json',
    `source_root/index.ts`,
    `source_root/index.client.ts`,
    `source_root/setupTest.ts`,
    `source_root/setupTest.updated.ts`,
    `source_root/api/index.ts`,
    `source_root/api/http.ts`,
    `source_root/components/ExampleHeader.tsx`,
    `source_root/links/index.ts`,
    `source_root/links/Nested.link.ts`,
    `source_root/links/Root.link.ts`,
    `source_root/routes/index.ts`,
    `source_root/routes/paths.ts`,
    `source_root/routes/routeStore.ts`,
    `source_root/pages/ExampleRootPage.tsx`,
    `source_root/pages/ExampleNestedPage.tsx`,
  ],
};

/**
 * App generator class.
 *
 * @extends BaseGenerator
 * @type {module.AppGenerator}
 */
module.exports = class AppGenerator extends BaseGenerator {
  /**
   * Method for "writing" phase of yeaoman generator.
   */
  writing() {
    this.writeTemplates(TEMPLATES);
  }
};
